---
feature_story: FS_80_82_13_35
feature_title: full option list on describe with prefix
feature_status: TODO
---


`CompType.DescribeArgs` is used together with `RunMode.InvocationMode` to use tangent token (FS_23_62_89_43).

However, when arg value is incomplete, there is no reduction of options shown in description:

```sh
some_command goto host pro|
```

Actual:

```
ClassFunction:
  ActionType: goto [ExplicitPosArg]
  ObjectSelector: host [ExplicitPosArg]
ClassCluster:
  *CodeMaturity: ? dev qa prod
  ...
```

Expected (ideally):

```
ClassFunction:
  ActionType: goto [ExplicitPosArg]
  ObjectSelector: host [ExplicitPosArg]
ClassCluster:
  *CodeMaturity: ? prod
  ...
```

If it was `RunMode.InvocationMode`, the suggestion is exactly how it works how (see Actual above).

*   So far, `argrelay` does not allow incomplete arg values in case of multiple options on invocation.
*   But reducing shown options for a given prefix on `CompType.DescribeArgs` is also not a completion (to make it work as Expected above).

Currently, instead of reducing options, prefix highlight (FS_11_87_76_73) is used.

TODO: However, sometimes tangent token matches one of the option exactly, and all options hide because
current becomes `ExplicitPosArg`. Ideally, we want suggestion to match what is proposed, for example:

```
relay_demo goto service tt|
```

Then, description prints this (only one):

```
ClassService: 1
  CodeMaturity: dev [ImplicitValue]
  FlowStage: downstream [ImplicitValue]
  GeoRegion: apac [ImplicitValue]
  ClusterName: dev-apac-downstream [ImplicitValue]
  GroupLabel: rrr [ImplicitValue]
  ServiceName: tt [ExplicitPosArg]
  HostName: zxcv-dd [ImplicitValue]
  LiveStatus: [none]
  DataCenter: dc.11 [ImplicitValue]
  IpAddress: ip.172.16.1.2 [ImplicitValue]
```

But suggestion lists these (several):

```
tt   tt1  tt2
```


